//
//	Gp02s.pas	99/02/12 R.Gotoh on Delphi 4.0
//		bp[֐̃CTv
//
unit AxpGp02s;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  AxpGp02w, StdCtrls;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
  private
		procedure ResultMessage(strbuf: String);
		procedure ErrorMessage(wLogSocket: Word);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const
	MAXBUFF=4096;		// Mp̃obt@l`w
	MYADRS=0;				// GPIBAhX
  PRTADRS=1;      // GPIBAhX

//---------------------------------------------------------------------------
// Form1 OnCreate
//---------------------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
var
	strbuf:	 			String;
	dwDLLVer, 		dwDrvVer: DWord;	// DLLCDrivero[W
	bResult:			Boolean;					// 
	wLogSocket:		Word;							// foCXi[
	wGpibAdrs:		Word;							// haAhX
	wGpibMode:		Word;							// ha[h
	dwFifoSize:		DWord;						// haobt@TCY
	dwTimeout:		DWord;						// ^CAEgl
	ri:						TGP02RESOURCE;		// \[X
	Buff:					array [0..MAXBUFF] of Byte;	// Mp̃obt@
	dwDataCnt:		DWord;						// Mf[^
	wSrqLine:			Word;							// rqpC
	bStsByte:			Byte;							// Xe[^XoCg
  i:						Word;							// [vpϐ
begin
	//---------------------------------------------------------------------------
	// DLL̎gp錾
	//---------------------------------------------------------------------------
	if Gp02wDllOpen()=False then ErrorMessage(GP02_SOCKET_AUTO);
	ResultMessage('DLL[h܂B');
	//---------------------------------------------------------------------------
	// DLL,VxD̃o[Wԍ擾
	//---------------------------------------------------------------------------
	if Gp02wGetVersion(dwDLLVer, dwDrvVer)=False then ErrorMessage(GP02_SOCKET_AUTO);
	strbuf := Format('o[Wԍ擾'#10 +
									 'DLL Version: %08xH'#10 +
									 'Drv Version: %08xH',[dwDLLVer, dwDrvVer]);
	ResultMessage(strbuf);
	//---------------------------------------------------------------------------
	// foCX̎gp錾
	//---------------------------------------------------------------------------
	wLogSocket := GP02_SOCKET_AUTO;			// gp̃foCXT܂B
	bResult := Gp02wCreate(wLogSocket);	// ꍇA̎̃foCXi[܂B
	if bResult=False then ErrorMessage(GP02_SOCKET_AUTO);
	strbuf := Format('foCX̎gp錾'#10#10 +
									 'LogSocket: %2d', [wLogSocket]);
	ResultMessage(strbuf);
	//---------------------------------------------------------------------------
	// \[X擾
	//---------------------------------------------------------------------------
	if Gp02wGetResource(wLogSocket, @ri)=False then ErrorMessage(wLogSocket);
	strbuf := Format('\[X擾'#10 +
									 'NumPorts: %2d'#10 +
									 'IO Address: %04xH - %04xH'#10 +
                   'IRQ: %2d',
										[ ri.dwIOPortLength[1],ri.dwIOPortBase[1],
										  ri.dwIOPortBase[1] + ri.dwIOPortLength[1]-1,
                      ri.dwIRQRegisters[1] ]);
	ResultMessage(strbuf);
	//---------------------------------------------------------------------------
	// AXP-GP02̏
	//---------------------------------------------------------------------------
	wGpibAdrs:=MYADRS;			// ̂haAhX
	wGpibMode:=MODE_SYSCON;	// Rg[ɂȂ
  dwFifoSize:=MAXBUFF;		// FIFOobt@TCYw
	if Gp02wInit(wLogSocket,wGpibAdrs,wGpibMode,dwFifoSize)=False then ErrorMessage(wLogSocket);
	strbuf := Format('AXP-GP02̏'#10#10 +
									 'My IB-Address: %2d'#10 +
                   'IB-Mode: %d'#10 +
                   'FifoSize: %d',[ wGpibAdrs,wGpibMode,dwFifoSize ]);
	ResultMessage(strbuf);
	//---------------------------------------------------------------------------
	// GP-IB ̃^CAEgݒ
	//---------------------------------------------------------------------------
	dwTimeout:=3000;	// ^CAEgl=Rb
	if Gp02wSetTime(wLogSocket,dwTimeout)=False then ErrorMessage(wLogSocket);
	strbuf := Format('GP-IB̃^CAEgݒ'#10#10 +
									 'Timeout: %dmSec'#10,[ dwTimeout ]);
	ResultMessage(strbuf);
	//---------------------------------------------------------------------------
	// f~^Ƃdnhݒ
	//---------------------------------------------------------------------------
	if Gp02wSetEos(wLogSocket,DELIM_CRLF,EOI_ON)=False then ErrorMessage(wLogSocket);
	strbuf := 'f~^Ƃdnhݒ'#10#10 + ': CR+LF'#10 + 'EOI: On';
	ResultMessage(strbuf);
	//---------------------------------------------------------------------------
	// heb̑MiRg[pj
	//---------------------------------------------------------------------------
	if Gp02wIfc(wLogSocket)=False then ErrorMessage(wLogSocket);
	strbuf := 'heb̑M';
	ResultMessage(strbuf);
	//---------------------------------------------------------------------------
	// w@ւ̃f[^MiRg[pj
	//---------------------------------------------------------------------------
	wGpibAdrs:=PRTADRS;			// XîhaAhX
  dwDataCnt:=10;					// Mf[^
	for i:=0 to 9 do Buff[i]:=Ord('0')+i;
	if Gp02wSendDataC(wLogSocket,wGpibAdrs,Buff,dwDataCnt)=False then ErrorMessage(wLogSocket);
	strbuf := 'w@ւ̃f[^M';
	ResultMessage(strbuf);
	//---------------------------------------------------------------------------
	// w@킩̃f[^MiRg[pj
	//---------------------------------------------------------------------------
	wGpibAdrs:=PRTADRS;			// g[ĴhaAhX
  dwDataCnt:=50;					// Mf[^
  if Gp02wRecvDataC(wLogSocket,wGpibAdrs,Buff,dwDataCnt)=False then ErrorMessage(wLogSocket);
	Buff[dwDataCnt]:=0;
	strbuf := Format('w@킩̃f[^M'#10#10 +
  								 'DataCnt: %d'#10 +
        			     'Data: %s',[ dwDataCnt,PChar(@Buff) ]);
	ResultMessage(strbuf);
	//---------------------------------------------------------------------------
	// rqpC̏ԔiRg[pj
	//---------------------------------------------------------------------------
	if Gp02wGetSrqLine(wLogSocket,wSrqLine)=False then ErrorMessage(wLogSocket);
	strbuf := Format('rqpC̏Ԕ'#10#10 +
  								 'SRQline: %d',[ wSrqLine ]);
	ResultMessage(strbuf);
	//---------------------------------------------------------------------------
	// VA|[siRg[pj
	//---------------------------------------------------------------------------
	if wSrqLine=1 then begin
		wGpibAdrs:=PRTADRS;				// VA|[haAhX
		if Gp02wSpoll(wLogSocket,wGpibAdrs,bStsByte)=False then ErrorMessage(wLogSocket);
		strbuf := Format('VA|[s'#10#10 +
	  								 'STS Byte: %x',[ bStsByte ]);
		ResultMessage(strbuf);
  end;
	//---------------------------------------------------------------------------
	// foCX̎gpI
	//---------------------------------------------------------------------------
	if Gp02wClose(wLogSocket)=False then ErrorMessage(GP02_SOCKET_AUTO);
	strbuf := Format('foCX̎gpI'#10#10 +
									 'LogSocket: %2d', [wLogSocket]);
	ResultMessage(strbuf);
	//---------------------------------------------------------------------------
	// DLL̃A[h
	//---------------------------------------------------------------------------
  Gp02wDllClose;
	Halt(1);
end;
//---------------------------------------------------------------------------
// ʂ\
//---------------------------------------------------------------------------
procedure TForm1.ResultMessage(strbuf: String);
begin
	Application.MessageBox(PChar(strbuf), 'AXP-GP02', MB_OK + MB_ICONINFORMATION);
end;
//---------------------------------------------------------------------------
// G[bZ[W\ďI
//---------------------------------------------------------------------------
procedure TForm1.ErrorMessage(wLogSocket: Word);
var
	dwRes: DWord;
	strbuf: String;
begin
	dwRes := Gp02wGetLastError(wLogSocket);
	case dwRes of
		GP02_ERR_SYSTEM:	strbuf := Format('System error'#10#10'Error code: %08xH', [GetLastError()]);
		GP02_ERR_WRAPDLL: strbuf := 'DLL Load error';
		else              strbuf := Format('AXP-GP02 error'#10#10'Error code: %08xH',[dwRes]);
	end;
	Application.MessageBox(PChar(strbuf), 'AXP-GP02', MB_OK + MB_ICONSTOP);
	// I
	Gp02wClose(wLogSocket);
  Gp02wDllClose;
	Halt(1);
end;

end.
